/***********************************************************************************************************************
 *
 * OpenBlueSky - NetBeans Platform Enhancements
 * Copyright (C) 2006-2011 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://openbluesky.java.net
 * SCM: https://bitbucket.org/tidalwave/openbluesky-src
 *
 **********************************************************************************************************************/
package it.tidalwave.netbeans.automatedtest;

import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;
import java.util.HashMap;
import java.util.Map;
import javax.annotation.Nonnull;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
public class FunctionBean<T>
  {
    public static final String PROP_VALUE = "value";

    private PropertyChangeSupport propertyChangeSupport = new PropertyChangeSupport(this);

    private boolean bindingDone;

    protected T value;

    private final Map<String, Object> beanMapByName = new HashMap<String, Object>();

    public static <T> FunctionBean<T> create (@Nonnull final String expression)
      {
        return new FunctionBean<T>();
      }

    public FunctionBean<T> bind (@Nonnull final String name, @Nonnull final Object o)
      {
        beanMapByName.put(name, o);
        return this;
      }

    public T getValue()
      {
        if (!bindingDone)
          {

            bindingDone = true;
          }

        return value;
      }

    public void addPropertyChangeListener (final PropertyChangeListener listener)
      {
        propertyChangeSupport.addPropertyChangeListener(listener);
      }

    public void removePropertyChangeListener (final PropertyChangeListener listener)
      {
        propertyChangeSupport.removePropertyChangeListener(listener);
      }
  }
